//AR2Gun.cs

//audio
datablock AudioProfile(AR2GunShot1Sound)
{
   filename    = "./gunShot1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(AR2gunChargeSound)
{
   filename    = "./charging.wav";
   description = AudioClose3d;
   preload = true;
};


//muzzle flash effects
datablock ParticleData(AR2GunFlashParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50; //25
	lifetimeVarianceMS   = 15; //15
	textureName          = "base/data/particles/star1";
	spinSpeed		= 100.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.68 0.8 0.48 0.4"; //0.9 0.82 0.42 0.9
	colors[1]     = "0.48 0.98 0.59 0.4"; //0.9 0.9 0.0 0.9
	colors[2]     = "0.48 0.98 0.59 0.4";
	sizes[0]      = 0.75;
	sizes[1]      = 0.5;
	sizes[2]      =  0.3;
	//times[0]       = 0.0;
	//times[1]       = 0.30;
	//times[2]       = 0.75;

	useInvAlpha = false;
};
datablock ParticleEmitterData(AR2GunFlashEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 40.0; //1.0
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;//90
   phiReferenceVel  = 0;
   phiVariance      = 0;//360
   overrideAdvance = false;
   particles = "AR2GunFlashParticle";

   uiName = "AR2Gun Flash";
};

datablock ParticleData(AR2TracerParticle)
{
	textureName          = "base/data/particles/dot";
	dragCoefficient      = 10;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0;
	spinSpeed     = 0;
	spinRandomMin = -90.0;
	spinRandomMax =  90.0;
	useInvAlpha   = false;

	colors[0]	= "0.28 0.98 0.39 0.4";
	colors[1]	= "0.48 0.98 0.59 0.2";
	colors[2]	= "0.48 0.98 0.59 0.0";

	sizes[0]	= 0.25;
	sizes[1]	= 0.2;
	sizes[2]	= 0;

	times[0]	= 0;
	times[1]	= 0.2;
    times[2]	= 1.0;
};
datablock ParticleEmitterData(AR2TracerEmitter)
{
	//lifeTimeMS = 25;

   ejectionPeriodMS = 2; //3
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0; //89
   thetaMax         = 90; //90

   overrideAdvance = false;
   particles = "AR2TracerParticle";

   useEmitterColors = true;
   uiName = "AR2 Tracer Emitter";
};


//datablock ParticleData(AR2GunSmokeParticle)
//{
//	dragCoefficient      = 3;
//	gravityCoefficient   = -0.5;
//	inheritedVelFactor   = 0.2;
//	constantAcceleration = 0.0;
//	lifetimeMS           = 525;
//	lifetimeVarianceMS   = 55;
//	textureName          = "base/data/particles/cloud";
//	spinSpeed		= 40.0;
//	spinRandomMin		= -500.0;
//	spinRandomMax		= 900.0;
//	colors[0]     = "0.5 0.5 0.5 0.9";
//	colors[1]     = "0.5 0.5 0.5 0.0";
//	sizes[0]      = 0.15;
//	sizes[1]      = 0.15;

//	useInvAlpha = false;
//};
//datablock ParticleEmitterData(AR2GunSmokeEmitter)
//{
//   ejectionPeriodMS = 3;
//   periodVarianceMS = 0;
//   ejectionVelocity = 1.0;
//   velocityVariance = 1.0;
//   ejectionOffset   = 0.0;
//   thetaMin         = 0;
//   thetaMax         = 90;
//   phiReferenceVel  = 0;
//   phiVariance      = 360;
//   overrideAdvance = false;
//   particles = "AR2GunSmokeParticle";

//   uiName = "AR2Gun Smoke";
//};

AddDamageType("AR2Gun",   '<bitmap:add-ons/Weapon_AR2Gun/CI_AR2Gun> %1',    '%2 <bitmap:add-ons/Weapon_AR2Gun/CI_AR2Gun> %1',0.2,1);
datablock ProjectileData(AR2GunProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 16;
   directDamageType    = $DamageType::AR2Gun;
   radiusDamageType    = $DamageType::AR2Gun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = GunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "AR2 Bullet";
};


AddDamageType("AR2GunTracer",   '<bitmap:add-ons/Weapon_AR2Gun/CI_AR2Gun> %1',    '%2 <bitmap:add-ons/Weapon_AR2Gun/CI_AR2Gun> %1',0.2,1);
datablock ProjectileData(AR2GunTracerProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::AR2GunTracer;
   radiusDamageType    = $DamageType::AR2GunTracer;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   //explosion           = GunExplosion;
   particleEmitter     = "AR2TracerEmitter"; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0.5 0";

   uiName = "AR2 Tracer";
};

//////////
// item //
//////////
datablock ItemData(AR2GunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./AR2Gun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "AR2";
	iconName = "./icon_AR2Gun";
	doColorShift = true;
	colorShiftColor = "0.27 0.28 0.37 1.000";

	 // Dynamic properties defined by the scripts
	image = AR2GunImage;
	canDrop = true;
	
    maxAmmo = 30;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(AR2GunImage)
{
   // Basic Item properties
   shapeFile = "./AR2Gun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = AR2GunItem;
   ammo = " ";
   projectile = AR2GunProjectile;
   projectileType = Projectile;

	//casing = GunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
	
	        raycastWeaponRange = 200; //varies
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = GunProjectile;
   raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 16;
   raycastDirectDamageType = $DamageType::AR2Gun;
   raycastTracerProjectile = AR2GunTracerProjectile;
   raycastSpreadAmt = 0.001; //varies
   raycastSpreadCount = 1;
   raycastFromMuzzle = true;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = AR2GunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateSequence[0]		        = "Root";
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateSound[0]			        = weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	    = "ReloadStart";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateScript[1]                  = "onReady";
	stateSequence[1]			    = "ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.025; //0.0025 x2
	stateEjectShell[2]              = true;
	stateSequence[2]                = "Fire";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= AR2GunFlashEmitter;
	stateEmitterTime[2]		= 0.025;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= AR2GunShot1Sound;

	stateName[3] 			= "Smoke";
	stateTimeoutValue[3]     = 0.0025;
	//stateEmitter[3]			= AR2GunSmokeEmitter;
	stateEmitterTime[3]		= 0.10;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3] = "Wait";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0;
	stateTransitionOnTimeout[4]	= "LoadCheckA";
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Ready";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ReloadStart";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "ReloadStart";
	stateSequence[8]            = "Reload";
	stateTimeoutValue[8]			= 0.85;
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "Reloaded";
	stateWaitForTimeout[8]			= true;
	
	stateName[9]				= "Reloaded";
	stateTimeoutValue[9]			= 0.3;
	stateScript[9]				= "onReloaded";
	//stateSound[9]                           = "FWReload1sound";
    stateTransitionOnTimeout[9]		= "Ready";
};

function AR2GunImage::onReady(%this,%obj,%slot)
{
commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>5.56 Rounds: <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["556rounds"] @ "", 1, 2, 3, 4); 
}

function AR2GunImage::onFire(%this,%obj,%slot)
{
	//%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
	if(%obj.getDamagePercent() >= 1.0)
		return;
	
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.raycastSpreadAmt = 0.00175;
		%this.raycastWeaponRange = 200;
	}
	else
	{
		%this.raycastSpreadAmt = 0.001;
		%this.raycastWeaponRange = 200;
	}
	
	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		Parent::onFire(%this,%obj,%slot);
		%obj.toolAmmo[%obj.currTool]--;
		%obj.AmmoSpent[%obj.currTool]++;
commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>5.56 Rounds: <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["556rounds"] @ "", 1, 2, 3, 4);  
	}
	else if(%this.item.maxAmmo == 0)
	{
		Parent::onFire(%this,%obj,%slot);
	}
	
	
	%obj.playThread(2, plant);	
}

function AR2GunImage::onReloadStart(%this,%obj,%slot)
{
commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>5.56 Rounds: <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["556rounds"] @ "", 1, 2, 3, 4);   
    if(%obj.client.quantity["556rounds"] >= 1)
	{
	%obj.playThread(2, plant);
            serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	}
}

function AR2GunImage::onReloaded(%this,%obj,%slot)
{
    if(%obj.client.quantity["556rounds"] >= 1)
	{

	%obj.playThread(2, plant);
        if(%obj.client.quantity["556rounds"] > %this.item.maxAmmo)
	{
		%obj.client.quantity["556rounds"] -= %obj.AmmoSpent[%obj.currTool];
		%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
		%obj.AmmoSpent[%obj.currTool] = 0;
            serverPlay3D(Block_PlantBrick_Sound,%obj.getPosition());
		%obj.setImageAmmo(%slot,1);
commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>5.56 Rounds: <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["556rounds"] @ "", 1, 2, 3, 4);   
		return;
	}

        if(%obj.client.quantity["556rounds"] <= %this.item.maxAmmo)
	{
		%obj.client.exchangebullets = %obj.client.quantity["556rounds"];
		%obj.toolAmmo[%obj.currTool] = %obj.client.exchangebullets;
		%obj.setImageAmmo(%slot,1);
            serverPlay3D(Block_PlantBrick_Sound,%obj.getPosition());
		%obj.client.quantity["556rounds"] = 0;
commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>5.56 Rounds: <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["556rounds"] @ "", 1, 2, 3, 4);   
		return;
	}
  }
}

	package AR2AltFire
{
	function Armor::onTrigger(%this, %player, %slot, %val)
   	{
      		if(%player.getMountedImage(0) $= AR2GunImage.getID() && %slot $= 4 && %val)     // Make sure the "AR2gunImage" is changed to your weaponImage.
      		{
         		if(%player.lastAlt !$= "" && getSimTime() - %player.lastAlt < 10000) //10000
         		{
	    			%player.playThread(2, plant);
	    			serverPlay3D(HL2PistolClickSound,%player.getPosition());	// Unable to fire sound, I used my pistolClick.
            			return;
         		}

         		serverPlay3D(AR2gunChargeSound,%player.getPosition());		// This is the charge sound, you can probably just rip this straight out of hl2 for it to work, just make sure it lasts about 1000ms.
				%player.schedule(0,0,playThread, 2, plant);//shiftLeft
				//%player.schedule(111,0,playThread, 2, plant);
				//%player.schedule(222,0,playThread, 2, shiftRight);
				//%player.schedule(333,0,playThread, 2, shiftLeft);
				//%player.schedule(444,0,playThread, 2, plant);
				//%player.schedule(555,0,playThread, 2, shiftRight);
				//%player.schedule(666,0,playThread, 2, shiftLeft);
				//%player.schedule(777,0,playThread, 2, plant);
				//%player.schedule(888,0,playThread, 2, shiftRight);
				//%player.schedule(999,0,playThread, 2, plant);
				schedule(450,0,AR2gunAltFire,%this, %player, %slot, %val); //1000
        		%player.lastAlt = getSimTime();
      		}
      		Parent::onTrigger(%this, %player, %slot, %val);
   	}
};
ActivatePackage(AR2AltFire);

function AR2gunAltFire(%this, %player, %slot, %val)
{
		 %projectile = energyBallProjectile;
		 %spread = 0.0015;
         %vector = %player.getMuzzleVector(0);
         %objectVelocity = %player.getVelocity();
         %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
         %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
         %velocity = VectorAdd(%vector1,%vector2);
		 %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		 %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		 %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		 %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	  	 %velocity = MatrixMulVector(%mat, %velocity);
         %p = new Projectile()
         {
            	dataBlock = %projectile;
            	initialVelocity = %velocity;
            	initialPosition = %player.getMuzzlePoint(0);
            	sourceObject = %player;
            	sourceSlot = 0;
            	client = %player.client;
         };
         serverPlay3D(AR2gunAltFireSound,%player.getPosition());	// Find a fire sound for the AR2 blast.
		 %player.playThread(2, jump);
         MissionCleanup.add(%p);
         return %p;
}
